<?php
# Formating functions
#
# $Id: format.php,v 1.4 2005/06/29 15:01:59 gf Exp $
#
# Copyright (c) 2004 Georgi Chorbadzhiyski
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
# permitted provided that the following conditions are met:
#
# 1. Redistributions of this script must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
#  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
#  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO
#  EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
#  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
#  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
#  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
#  ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
	if (LIB_INCLUDE != 1)
		exit;

	$months_txt = array(
		1	=>	"",
		2	=>	"",
		3	=>	"",
		4	=>	"",
		5	=>	"",
		6	=>	"",
		7	=>	"",
		8	=>	"",
		9	=>	"",
		10	=>	"",
		11	=>	"",
		12	=>	""
	);

	$days_txt = array(
		0	=>	"",
		1	=>	"",
		2	=>	"",
		3	=>	"",
		4	=>	"",
		5	=>	"",
		6	=>	""
	);

	/*  YYYY-MM-DD  , DD  YYYY */
	function format_date($date) {
		global $months_txt, $days_txt;

		$dt = strtotime($date);
		$ret = $days_txt[date("w", $dt)];
		$ret .= ereg_replace(" 0"," ",date(", d ",$dt));
		$ret .= $months_txt[(int)date("m",$dt)];
		$ret .= date(" Y",$dt);
		return $ret;
	}

	/*     */
	function get_title($date) {
		return format_date($date);
	}

	/*      */
	function format_day($text) {
		$text = trim(ltrim($text,"\n"),"\n");
		$text = ereg_replace("^([0-9]{2}:[0-9]{2})\n","<b><small>\\1</small></b>\n<p>",$text);
		$text = ereg_replace("\n([0-9]{2}:[0-9]{2})\n","</p>\n<b><small>\\1</small></b>\n<p>",$text);
		$text = ereg_replace("\n\n","</p>\n<p>",$text);
		if (!ereg("^<", $text))
			$text = "<p>" . $text;
		$text .= "</p>";
		return $text;
	}

	/*     */
	function format_comment($text) {
		$text = ereg_replace("\\\\n","\n",$text);

		while (ereg("[^[:space:]]{50,}",$text)) {
			$text = ereg_replace("([^[:space:]]{49})","\\1 ",$text);
		}
		while (ereg("[:space:]{10,}",$text)) {
			$text = ereg_replace("[:space:]{10,}"," ",$text);
		}
		while (ereg("\n{4,}",$text)) {
			$text = ereg_replace("\n{4,}","\n",$text);
		}
		$text = ereg_replace("\\ n",'n',$text);

		return nl2br(htmlspecialchars($text));
	}

	/*         */
	function get_filename($fname) {
		return DAY_DIR . $fname . ".txt";
	}

	/*      $length */
	function gen_uniq($rnd=0,$length=12) {
		srand((double)microtime()*10000000+$rnd);
		$Pool = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz01234567890';
		$sid = '';
		for($index = 0; $index < $length; $index++) {
			$sid .= substr($Pool, (rand()%(strlen($Pool))), 1);
		}
		return($sid);
	}
?>