<?php
# Data load functions
#
# $Id: load.php,v 1.1 2005/04/28 16:55:27 gf Exp $
#
# Copyright (c) 2004 Georgi Chorbadzhiyski
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
# permitted provided that the following conditions are met:
#
# 1. Redistributions of this script must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
#  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
#  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO
#  EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
#  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
#  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
#  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
#  ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
	if (LIB_INCLUDE != 1)
		exit;

	/*    ,      */
	function load_days() {
		$days = array();
		if (is_dir(DAY_DIR) && is_readable(DAY_DIR)) {
			if ($dh = opendir(DAY_DIR)) {
				while (($day = readdir($dh)) !== false) {
					if (filetype(DAY_DIR . $day) == "file" &&
					    ereg("[0-9]{4}-[0-9]{2}-[0-9]{2}\.txt$", $day))
					{
						$day = ereg_replace(".txt$","",$day);
						$days[$day] = $day;
					}
				}
				closedir($dh);
			}
		} else {
			print "Can't open \"" . DAY_DIR . "\" directory.<br />Make sure the directory exists and has correct permissions!<br /><br />";
		}
		arsort($days); /* Sort descending */
		return $days;
	}

	/*        ,     */
	function load_months(&$days) {
		$months = array();
		foreach ($days as $tmp => $tmpdate) {
			$tmpdate = ereg_replace("-[0-9]+$","",$tmpdate);
			if (!isset($months[$tmpdate])) {
				$months[$tmpdate] = $tmpdate;
			}
		}
		asort($months);
		return $months;
	}

	/*     FEEDS_COMMENTS  */
	function load_last_comments() {
		$comments = array();
		$published = array();
		if (is_dir(COMMENT_DIR) && is_readable(COMMENT_DIR)) {
			if ($dh = opendir(COMMENT_DIR)) {
				while (($file = readdir($dh)) !== false) {
					if (filetype(COMMENT_DIR . $file) == "file" &&
					    ereg("[0-9]{4}-[0-9]{2}-[0-9]{2}\.comments\.txt$", $file))
					{
						@$stat = stat(COMMENT_DIR . $file);
						/* Last modified */
						$comments[$stat[9]] = $file;
					}
				}
				closedir($dh);
			}
			krsort($comments,SORT_NUMERIC); /* Sort descending */
			$comments = array_slice($comments, 0, FEEDS_COMMENTS);
			foreach ($comments as $ts => $comment_file) {
				$tmp = file(COMMENT_DIR . $comment_file);
				$date = ereg_replace(".comments.txt$","",$comment_file);
				foreach($tmp as $id => $line) {
					ereg("^([0-9]+)",$line,$cmt);
					$published["{$cmt[1]} {$date}"] = trim($line);
				}
			}
			krsort($published); /* Sort descending */
			$comments = array_slice($published, 0, FEEDS_COMMENTS);
		} else {
			print "Can't open \"" . COMMENT_DIR . "\" directory.<br />Make sure the directory exists and has correct permissions!<br /><br />";
		}
		return $comments;
	}

	/*      */
	function load_adventures() {
		$adventures = array();
		$filename = get_filename("adventures");
		if (file_exists($filename)) {
			$adv = file($filename);
			foreach ($adv as $i => $text) {
				list($name,$title,$alldates) = split(";", $text);
				$dates = array(); $dates = split(" ",trim(ltrim($alldates)));
				$adventures[$name]["title"] = $title;
				$adventures[$name]["dates"] = $dates;
			}
		}
		return $adventures;
	}
?>