<?php
# Display formatted texts and comments
#
# $Id: show.php,v 1.8 2005/06/29 15:01:59 gf Exp $
#
# Copyright (c) 2004 Georgi Chorbadzhiyski
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
# permitted provided that the following conditions are met:
#
# 1. Redistributions of this script must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
#  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
#  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO
#  EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
#  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
#  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
#  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
#  ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
	if (LIB_INCLUDE != 1)
		exit;

	/*    ,      */
	function show_comment($text, $author, $email, $url, $published, $last_comment=false) {
		$text = format_comment(trim(ltrim($text)));
		print "<p class=\"comment\">" . ereg_replace("\n","",$text) . "</p>\n";
		if (!$last_comment) {
			print "<p class=\"author\">";
		} else {
			print "<p>";
		}
		print " <b>".htmlspecialchars($author)."</b> ";
		if (strlen($email)) {
			// $email = ereg_replace("@", "__",$email);
			print " (<a href=\"mailto:" . urlencode($email) . "\">email</a>)";
		}
		if (strlen($url)) {
			$url = ereg_replace('"',"",$url);
			print " (<a rel=\"nofollow\" href=\"http://" . ereg_replace("^http://","",$url) . "\">www</a>)";
		}
		print "  <b>".date("d-M-Y H:i", $published)."</b></p>\n";
	}

	/*     ,      */
	function print_comments($date) {
		$comments = array();
		$total_comments = 0;
		$comment_file = COMMENT_DIR . $date . ".comments.txt";

		if (file_exists($comment_file) && is_readable($comment_file)) {
			$tmp = file($comment_file);
			$total_comments = count($tmp);
			print "<span class=\"cmtlinks\">[ : <b>{$total_comments}</b> / <a href=\"" . BASEDIR . "addcomment.php/{$date}#add\"> </a> ]</span>\n";
			if ($total_comments) {
				/* Sort comments by ts */
				$comments = array();
				foreach ($tmp as $id => $comment_text) {
					ereg("^([0-9]+)",$comment_text,$cmt);
					$comments[$cmt[1]] = $comment_text;
				}
				ksort($comments, SORT_NUMERIC);

				print "<blockquote id=\"cmt{$date}\">\n<h5></h5>\n";
				$cnt = 0;
				foreach($comments as $id => $line) {
					@list($published, $ip, $proxy, $ua, $author, $email, $url, $text) = split("\t", $line);
					if ($published > 0) {
						print "<a name=\"{$published}\"></a>\n";
						if ($cnt+1 == $total_comments) {
							print "<a name=\"lastcomment\"></a>\n";
						}
						$cnt++;
						show_comment($text, $author, $email, $url, $published, $cnt == $total_comments);
						if ($cnt < $total_comments) {
							print "<hr noshade = \"noshade\" />\n";
						}
					}
				}
				print "<br />\n</blockquote>\n";
			}
		} else {
			print "<span class=\"cmtlinks\">[ <a href=\"" . BASEDIR . "addcomment.php/{$date}#add\"> </a> ]</span>\n";
		}
	}

	/*         ,         */
	function print_day($date, $text) {
		global $days_txt, $months_txt;
		$text = format_day($text);
?>
<a name="<?=$date?>"></a>
<h5><a href="<?=BASEDIR?>archive.php/<?=$date?>"><?=get_title($date)?></a></h5>
<?=$text?>
<?
		print_comments($date);
	}
?>